Bug 145689 - Unaligned stack pointer while initializing dynamic library
Summary: Unaligned stack pointer while initializing dynamic library
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: glibc   
(Show other bugs)
Version: 3
Hardware: i686 Linux
medium
medium
Target Milestone: ---
Assignee: Jakub Jelinek
QA Contact: Brian Brock
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2005-01-20 17:25 UTC by Phuc LeHong
Modified: 2007-11-30 22:10 UTC (History)
1 user (show)

Fixed In Version: 2.3.4-10
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-02-14 17:52:31 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Test case using SSE2 (1.19 KB, application/octet-stream)
2005-01-20 17:28 UTC, Phuc LeHong
no flags Details
Proposed glibc patch (580 bytes, patch)
2005-01-20 17:44 UTC, Phuc LeHong
no flags Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2005:096 normal SHIPPED_LIVE glibc bug fix update 2005-06-09 04:00:00 UTC
Sourceware 735 None None None Never

Description Phuc LeHong 2005-01-20 17:25:51 UTC
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; rv:1.7.3) Gecko/20041020
Firefox/0.10.1

Description of problem:
Dynamic libraries are initialized with a stack pointer that is not
aligned to a 16 bytes boundary. This is unfortunate for those who are
using SSE2 instructions.


Version-Release number of selected component (if applicable):
glibc-2.3.4-2.fc3

How reproducible:
Always

Steps to Reproduce:
1. untar the attached PR.tar and run make
2. set LD_LIBRARY_PATH=<PR directory>
3. 
    

Actual Results:  ./main gives "Memory fault" while ./s-main completes
with no error.

Expected Results:  Both executables should run Ok.

Additional info:

The test case requires SSE2 CPUs, ie Pentium 4 or x86_64 in 32 bits
compatibility mode. The problem doesn't occur in x86_64 in 64 bits mode.

Comment 1 Phuc LeHong 2005-01-20 17:28:40 UTC
Created attachment 110022 [details]
Test case using SSE2

Comment 2 Phuc LeHong 2005-01-20 17:44:43 UTC
Created attachment 110023 [details]
Proposed glibc patch

Comment 3 Phuc LeHong 2005-01-20 17:46:40 UTC
The glibc patch solved the problem for me, but I'm not a glibc expert
so there might be better ways to solve the problem.


Comment 6 Tim Powers 2005-06-09 11:14:38 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2005-096.html



Note You need to log in before you can comment on or make changes to this bug.